# CAWEZ's Dimensional Connectivity
A simple lightweight Minecraft mod that allows for stacking dimensions.

The mod will generate a config file with the tag "default", stacking the End, the Nether and the Overworld. It will be overwritten automatically by CAWEZ's Mantle to Stratus (unless the name is changed from "default"). The mod will place "well blocks" (pitch black) on the height/depth if the ceiling/floor block is replaced to hide the skybox.


Sample format:
```
{
    "name": "default",
    "stack": {
        "minecraft:the_end":{
            "dim_height": 256,
            "ceiling_replace": "none",
            "ceiling_with": "none",
            "dim_above": "none",

            "dim_depth": 0,
            "floor_replace": "none",
            "floor_with": "none",
            "dim_below": "minecraft:overworld"
        },

        "minecraft:overworld":{
            "dim_height": 320,
            "ceiling_replace": "none",
            "ceiling_with": "none",
            "dim_above": "minecraft:the_end",

            "dim_depth": -64,
            "floor_replace": "minecraft:bedrock",
            "floor_with": "minecraft:obsidian",
            "dim_below": "minecraft:the_nether"
        },
        
        "minecraft:the_nether":{
            "dim_height": 128,
            "ceiling_replace": "minecraft:bedrock",
            "ceiling_with": "minecraft:obsidian",
            "dim_above": "minecraft:overworld",

            "dim_depth": 0,
            "floor_replace": "none",
            "floor_with": "none",
            "dim_below": "none"
        }
    }
}
```
