package net.mcreator.cawezsdimensionalconnectivity.procedures;

import net.neoforged.fml.event.lifecycle.FMLCommonSetupEvent;
import net.neoforged.fml.common.EventBusSubscriber;
import net.neoforged.bus.api.SubscribeEvent;
import net.neoforged.bus.api.Event;
import java.io.File;  // Import the File class
import java.io.IOException;  // Import the IOException class to handle errors
import java.io.FileWriter;   





import javax.annotation.Nullable;

@EventBusSubscriber(bus = EventBusSubscriber.Bus.MOD)
public class GeneratedefaultProcedure {

	static String fileName = "config/cc_dim_stack.json";

	@SubscribeEvent
	public static void init(FMLCommonSetupEvent event) {
		execute();
	}

	public static void execute() {
		execute(null);
	}

	private static void execute(@Nullable Event event) {
		try {
      		File myObj = new File(fileName);
      		if (myObj.createNewFile()) {
        		System.out.println("File created: " + myObj.getName());

        		FileWriter myWriter = new FileWriter(fileName);
    			myWriter.write("{\n\t\"name\": \"default\",\n\t\"stack\": {\n\t\t\"minecraft:the_end\":{\n\t\t\t\"dim_height\": 256,\n\t\t\t\"ceiling_replace\": \"none\",\n\t\t\t\"ceiling_with\": \"none\",\n\t\t\t\"dim_above\": \"none\",\n\n\t\t\t\"dim_depth\": 0,\n\t\t\t\"floor_replace\": \"none\",\n\t\t\t\"floor_with\": \"none\",\n\t\t\t\"dim_below\": \"minecraft:overworld\"\n\t\t},\n\n\t\t\"minecraft:overworld\":{\n\t\t\t\"dim_height\": 320,\n\t\t\t\"ceiling_replace\": \"none\",\n\t\t\t\"ceiling_with\": \"none\",\n\t\t\t\"dim_above\": \"minecraft:the_end\",\n\n\t\t\t\"dim_depth\": -64,\n\t\t\t\"floor_replace\": \"minecraft:bedrock\",\n\t\t\t\"floor_with\": \"minecraft:obsidian\",\n\t\t\t\"dim_below\": \"minecraft:the_nether\"\n\t\t},\n\t\t\n\t\t\"minecraft:the_nether\":{\n\t\t\t\"dim_height\": 128,\n\t\t\t\"ceiling_replace\": \"minecraft:bedrock\",\n\t\t\t\"ceiling_with\": \"minecraft:obsidian\",\n\t\t\t\"dim_above\": \"minecraft:overworld\",\n\n\t\t\t\"dim_depth\": 0,\n\t\t\t\"floor_replace\": \"none\",\n\t\t\t\"floor_with\": \"none\",\n\t\t\t\"dim_below\": \"none\"\n\t\t}\n\t}\n}");
	      		myWriter.close();
	      		
      		} else {
        		System.out.println("File already exists.");
      		}
    	} catch (IOException e) {
	    	System.out.println("An error occurred.");
    		e.printStackTrace();
    	}
	}
}
/* Default config
{
    "name": "default",
    "stack": {
        "minecraft:the_end":{
            "dim_height": 256,
            "ceiling_replace": "none",
            "ceiling_with": "none",
            "dim_above": "none",

            "dim_depth": 0,
            "floor_replace": "none",
            "floor_with": "none",
            "dim_below": "minecraft:overworld"
        },

        "minecraft:overworld":{
            "dim_height": 320,
            "ceiling_replace": "none",
            "ceiling_with": "none",
            "dim_above": "minecraft:the_end",

            "dim_depth": -64,
            "floor_replace": "minecraft:bedrock",
            "floor_with": "minecraft:obsidian",
            "dim_below": "minecraft:the_nether"
        },
        
        "minecraft:the_nether":{
            "dim_height": 128,
            "ceiling_replace": "minecraft:bedrock",
            "ceiling_with": "minecraft:obsidian",
            "dim_above": "minecraft:overworld",

            "dim_depth": 0,
            "floor_replace": "none",
            "floor_with": "none",
            "dim_below": "none"
        }
    }
}
 */

